%{expand: %%define pyver %(python -c 'import sys;print(sys.version[0:3])')}

Summary: A multi-sourced configuration back-end.
Name: alchemist
Version: 1.0.34
Release: 1.XOS.1
License: GPL
Group: System Environment/Base
Source0: %{name}-%{version}.tar.gz
Prereq: /sbin/ldconfig
Requires: libxml2 >= 2.3.8, libxslt >= 0.9.0
Requires: python-abi = %{pyver}
BuildPreReq: libxml2 >= 2.3.8, libxslt >= 0.9.0, libxslt-devel >= 0.9.0
BuildPreReq: doxygen >= 1.2.7, python-devel, zlib-devel
BuildRequires: glib2-devel >= 2.0
BuildRoot: %{_tmppath}/%{name}-root

%description
The alchemist is a back-end configuration architecture, which provides
multi-sourced configuration at the data level, postponing translation to
native format until the last stage. It uses XML as an intermediary data
encoding, and can be extended to arbitrarily large configuration scenarios.

%package devel
Summary: Files needed for developing programs which use alchemist.
Group: Development/Libraries
Requires: %{name} == %{version}-%{release}

%description devel
The alchemist is a back-end configuration architecture, which provides
multi-sourced configuration at the data level, postponing translation to
native format until the last stage. It uses XML as an intermediary data
encoding, and can be extended to arbitrarily large configuration scenarios.

%prep
%setup -q

%build
export CFLAGS="-Wall -DNDEBUG -fPIC $RPM_OPT_FLAGS"
[ -f  /usr/share/automake/depcomp ] && cp -f /usr/share/automake/{depcomp,ylwrap} . || :
%configure --enable-shared --enable-static
make %{?_smp_mflags}

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
%makeinstall
mkdir -p $RPM_BUILD_ROOT/%{_mandir}
cd src
doxygen
cp -a doc/man/* $RPM_BUILD_ROOT/%{_mandir}/
python -O %{_libdir}/python%pyver/compileall.py $RPM_BUILD_ROOT%{_libdir}/python%pyver/site-packages

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_libdir}/python%{pyver}/site-packages/*
%{_libdir}/*.so.*
%dir %{_libdir}/alchemist
%dir %{_libdir}/alchemist/blackbox
%{_libdir}/alchemist/blackbox/*.so.*
%{_sysconfdir}/alchemist
%{_localstatedir}/cache/alchemist
%doc README

%files devel
%defattr(-,root,root)
%{_includedir}/alchemist
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_mandir}/*/*
%{_libdir}/alchemist/blackbox/*a
%{_libdir}/alchemist/blackbox/*.so
%doc src/doc/html

%changelog
* Thu Jul 28 2005 X/OS Linux Team <xoslinux@xos.nl> 1.0.34-1.XOS.1
- Build for X/OS Linux 4.
- X/OS Linux source rpm based on alchemist-1.0.34-1.src.rpm
  (md5sum of original source rpm: 4f3abb55f395a2734a64dbd3736f7dea).

* Wed Sep 22 2004 Than Ngo <than@redhat.com> 1.0.34-1
- add Prereq: /sbin/ldconfig

* Fri Mar  5 2004 Tim Waugh <twaugh@redhat.com> 1.0.33-1
- Require python-abi = %%{pyver} (bug #117501, bug #113313).

* Thu Feb 19 2004 Tim Waugh <twaugh@redhat.com> 1.0.32-1
- Unnest a function (bug #116248).

* Thu Jan 15 2004 Tim Waugh <twaugh@redhat.com> 1.0.31-1
- Fixed another accidental bitwise operation.

* Thu Jan  8 2004 Tim Waugh <twaugh@redhat.com> 1.0.30-1
- Fix several accidental bitwise operations.
- Unnest a function (bug #110691).

* Mon Jan  5 2004 Tim Waugh <twaugh@redhat.com> 1.0.29-1
- Own %%{_sysconfdir}/alchemist (bug #74024, bug #112842).
- Build requires glib2-devel (bug #110780).

* Thu Nov  6 2003 Tim Waugh <twaugh@redhat.com> 1.0.28-1
- Rebuilt (Python 2.3).

* Wed May 28 2003 Tim Waugh <twaugh@redhat.com> 1.0.27-2
- Rebuilt.

* Wed May 28 2003 Tim Waugh <twaugh@redhat.com> 1.0.27-1
- 1.0.27:
  - Switch to glib-2.0 (bug #91319).

* Mon Jan 27 2003 Tim Waugh <twaugh@redhat.com> 1.0.26-1
- Rebuild.

* Fri Dec 13 2002 Elliot Lee <sopwith@redhat.com> 1.0.25-1
- Rebuild, fix bugs

* Wed Jul 10 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.0.244
- Move the blackbox .a and .la file to the devel subpackage (#68461)

* Tue May 14 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.0.24-1
- Back to Python 2.2

* Tue Feb 26 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.0.23-1
- rebuild

* Thu Jan 24 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.0.22-1
- Make build with newer automake

* Thu Dec 13 2001 Trond Eivind Glomsrd <teg@redhat.com> 1.0.21-1
- Include .pyo files

* Fri Dec  7 2001 Trond Eivind Glomsrd <teg@redhat.com> 1.0.20-1
- s/Copyright/License/
- build for python 2.2

* Tue Dec  4 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.19-1
- removed AdmList_reparentData, it was a stupid idea
- added AdmList_renameCopyData, made AdmList_copyData use it.

* Thu Aug 23 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.18-1
- fixed thinko in pyalchemist_python.py found by pychecker
- added AdmList_reparentData() function, this will be hard to bind.

* Thu Aug 16 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.17-1
- added bindings for _isAlive to pyalchemist

* Tue Aug  7 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.16-1
- fixed internalized handler list so that it actually finds the fileblackbox

* Mon Aug  6 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.15-1
- give the fileblackbox children an open stdout and stderr to /dev/null,
- so they dont freak when they cannot write.

* Mon Aug  6 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.14-1
- fixed pyalchemist's writeCtx argument parsing.
- tweaked triggerblackbox so that it works.
- internalized fileblackbox, so we dont have to dl open it.

* Tue Jul 31 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.13-1
- fixed a 'fall off the list' bug in AdmList_moveData which was segfaulting

* Mon Jul 30 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.12-1
- changed all occurances of ADM_ENOBOXSET to ADM_ENOSUBSPACE
- tweaked the Doxygen settings to only list the contents of
- alchemist.h and blackbox.h
- told specfile to include the man pages

* Sun Jul 29 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.11-1
- limited names to 255 chars.

* Sun Jul 29 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.10-1
- added a validName function to the python bindings

* Sun Jul 29 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.0.9-1
- moved all function docs to the header.
- cleaned up the internal refstr engine
- exposed AdmData_validName, and extended names to match:
- Name = (Letter | '_') (Letter | Digit | '_' | '-' | '.')*

* Fri Jul 18 2001 Crutcher Dunnavant <crutcher@redhat.com>
- added zlib-devel build pre req, ldconfig call

* Fri Jul 13 2001 Crutcher Dunnavant <crutcher@redhat.com>
- added .strip() method to AdmContexts, which strips the Id tree

* Sun Jul 8 2001 Crutcher Dunnavant <crutcher@redhat.com>
- added .get() method to pyAdmLists

* Sun Jul 8 2001 Crutcher Dunnavant <crutcher@redhat.com>
- special case added to the pyalchemist binding AdmList getslice function,
- to handle asking for slices of empty lists

* Wed Jun 20 2001 Crutcher Dunnavant <crutcher@redhat.com>
- added alchemist dep to alchemist-devel

* Mon Jun 13 2001 Crutcher Dunnavant <crutcher@redhat.com>
- added some python helpers, has_key function

* Mon Jun 06 2001 Crutcher Dunnavant <crutcher@redhat.com>
- landed major devel work. feature complete

* Mon May 21 2001 Crutcher Dunnavant <crutcher@redhat.com>
- fixed AdmList_getChildByName, AdmList_getChildByPath, and AdmToken_nget

* Mon May 21 2001 Crutcher Dunnavant <crutcher@redhat.com>
- rebuilt with new binding system (Major changes)

* Mon Apr 23 2001 Nalin Dahyabhai <nalin@redhat.com>
- Obey RPM_OPT_FLAGS.  Obey.

* Fri Apr 19 2001 Crutcher Dunnavant <crutcher@redhat.com>
- fixed readVersion in the CacheBlackBox
- added URLBlackBok

* Mon Mar 05 2001 Philipp Knirsch <pknirsch@redhat.de>
- Fixed the "_cascade_merge_" name in the switchboard to be consistent with our
  new name validation.

* Wed Feb 28 2001 Crutcher Dunnavant <crutcher@redhat.com>
- changed valid_name to the pattern /^[a-zA-Z][-a-zA-Z0-9_]?$/,
- dropping the '-' and '_' characters as legal first characters
- (because they aren't legal XML first characters)

* Tue Feb 13 2001 Crutcher Dunnavant <crutcher@redhat.com>
- rebuilt for pknirsh's moveChild fix. (He should have written this changelog!)

* Fri Feb  9 2001 Trond Eivind Glomsrd <teg@redhat.com>
- Truncate files when opening for writing (ForgeBlackBox, FileBlackBox)

* Thu Feb 08 2001 Harald Hoyer <harald@redhat.de>
- fixed typos in ForgeBlackBox

* Wed Feb  7 2001 Crutcher Dunnavant <crutcher@redhat.com>
- tweaked the ForgeBlackBox to fix some include problems

* Wed Jan 31 2001 Crutcher Dunnavant <crutcher@redhat.com>
- check for name collides in non-anonymous lists at parse time. (oops.)

* Wed Jan 24 2001 Crutcher Dunnavant <crutcher@redhat.com>
- changed valid name to include '-' character

* Tue Jan 23 2001 Trond Eivind Glomsrd <teg@redhat.com>
- require 4Suite

* Mon Jan 22 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Fixed a bad break that I left in WriteContextToFile

* Mon Jan 22 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Fixed all occurances of Writeable to be Writable

* Thu Jan 18 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Reved the version to take into account Trond's ForgeBlackBox entry

* Sun Jan 14 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Add a CacheBlackBox, and some isNamespaceDirty logic to the alchemist
- to deal with some dirty cache nastyness

* Thu Jan 11 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Nope, Elliot had changed it to be case insensitive everywhere, reverted.

* Thu Jan 11 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Garh! Was doing case insensitive string comparisions for some reason.

* Tue Jan  9 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Fixed a bug in the import code that threw an uncaught exception

* Tue Jan  9 2001 Crutcher Dunnavant <crutcher@redhat.com>
- Changed Alchemist.py:Switchboard:writeNamespace() to return
- the context it writes, instead of None

* Wed Jan  3 2001 Crutcher Dunnavant <crutcher@redhat.com>
- initial packaging of alchemist

* Wed Dec 13 2000 Crutcher Dunnavant <crutcher@redhat.com>
- Created blank package for translation.
